//Messy, messy, messy...
enyo.kind({
	name: "PreferencesDialog",
	kind: "Scroller",
	align: "left",
	components: [
		//Name
		{kind: "Group", caption: "Device Name", components: [
				{name: "deviceNameInput", kind: "Input", onchange: "deviceNameChanged"},
		]},
		
		//Description
		{kind: "Group", caption: "Device Description", components: [
				{name: "deviceDescriptionInput", kind: "Input", onchange: "deviceDescriptionChanged"},
		]},
		
		//Shares
		{kind: "Group", caption: "Sharing", components: [
			//Public
			{name: "publicDividerDrawer", kind: "DividerDrawer", caption: "Public", onOpenChanged: "publicOpenChanged", components:[
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Available", flex: 1},
					{name: "publicAvailableCheck", kind: "CheckBox", onChange: "publicAvailableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Writeable", flex: 1},
					{name: "publicWriteableCheck", kind: "CheckBox", onChange: "publicWriteableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Browseable", flex: 1},
					{name: "publicBrowseableCheck", kind: "CheckBox", onChange: "publicBrowseableChanged"},
				]},
			]},
			//Internal
			{name: "internalDividerDrawer", kind: "DividerDrawer", caption: "Internal", onOpenChanged: "internalOpenChanged", components:[
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Available", flex: 1},
					{name: "internalAvailableCheck", kind: "CheckBox", onChange: "internalAvailableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Writeable", flex: 1},
					{name: "internalWriteableCheck", kind: "CheckBox", onChange: "internalWriteableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Browseable", flex: 1},
					{name: "internalBrowseableCheck", kind: "CheckBox", onChange: "internalBrowseableChanged"},
				]},
			]},
			//Root
			{name: "rootDividerDrawer", kind: "DividerDrawer", caption: "Root", onOpenChanged: "rootOpenChanged", components:[
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Available", flex: 1},
					{name: "rootAvailableCheck", kind: "CheckBox", onChange: "rootAvailableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Writeable", flex: 1},
					{name: "rootWriteableCheck", kind: "CheckBox", onChange: "rootWriteableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Browseable", flex: 1},
					{name: "rootBrowseableCheck", kind: "CheckBox", onChange: "rootBrowseableChanged"},
				]},
			]},
			//ext3fs
			{name: "ext3fsDividerDrawer", kind: "DividerDrawer", caption: "ext3fs", onOpenChanged: "ext3fsOpenChanged", components:[
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Available", flex: 1},
					{name: "ext3fsAvailableCheck", kind: "CheckBox", onChange: "ext3fsAvailableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Writeable", flex: 1},
					{name: "ext3fsWriteableCheck", kind: "CheckBox", onChange: "ext3fsWriteableChanged"},
				]},
				{kind: "Item", layoutKind: "HFlexLayout", align: "center", components: [
					{content: "Browseable", flex: 1},
					{name: "ext3fsBrowseableCheck", kind: "CheckBox", onChange: "ext3fsBrowseableChanged"},
				]},
			]},
		]},
	],
	
	setup: function() {
		enyo.log("Setting up Preferences Pane...");
		//Device
		this.$.deviceNameInput.setValue(smbSettings["global"]["netbios name"]);
		this.$.deviceDescriptionInput.setValue(smbSettings["global"]["server string"]);
		//Public Share
		this.$.publicDividerDrawer.setOpen(uiPrefs.Public.open);
		this.$.publicAvailableCheck.setChecked(smbSettings.Public.available);
		this.$.publicWriteableCheck.setChecked(smbSettings.Public.writable);
		this.$.publicBrowseableCheck.setChecked(smbSettings.Public.browseable);
		//Internal Share
		this.$.internalDividerDrawer.setOpen(uiPrefs.Internal.open);
		this.$.internalAvailableCheck.setChecked(smbSettings.Internal.available);
		this.$.internalWriteableCheck.setChecked(smbSettings.Internal.writable);
		this.$.internalBrowseableCheck.setChecked(smbSettings.Internal.browseable);
		//Root Share
		this.$.rootDividerDrawer.setOpen(uiPrefs.Root.open);
		this.$.rootAvailableCheck.setChecked(smbSettings.Root.available);
		this.$.rootWriteableCheck.setChecked(smbSettings.Root.writable);
		this.$.rootBrowseableCheck.setChecked(smbSettings.Root.browseable);
		//ext3fs Share
		if(smbSettings.ext3fs.detected == true)
		{
			this.$.ext3fsDividerDrawer.setOpen(uiPrefs.ext3fs.open);
			this.$.ext3fsAvailableCheck.setChecked(smbSettings.ext3fs.available);
			this.$.ext3fsWriteableCheck.setChecked(smbSettings.ext3fs.writable);
			this.$.ext3fsBrowseableCheck.setChecked(smbSettings.ext3fs.browseable);
		}
		else
		{
			this.$.ext3fsDividerDrawer.setShowing(false);
		}
	},
	
	//FIXME: Change from localStorage to pure smb.conf reading, less messy
	deviceNameChanged: function(inSender) {
		enyo.log("Setting Device Name...");
		samba.setPref("global", "netbios name", inSender.value);
	},
	
	deviceDescriptionChanged: function(inSender) {
		enyo.log("Setting Device Description...");
		samba.setPref("global", "server string", inSender.value);
	},
	
	publicOpenChanged: function(inSender) {
		enyo.log("Setting Public Open...");
		uiPrefs.Public.open = inSender.open;
	},
	
	publicAvailableChanged: function(inSender) {
		enyo.log("Setting Public Available...");
		smbSettings.Public.available = inSender.checked;
		samba.setPref("Public", "available", inSender.checked);
	},
	
	publicWriteableChanged: function(inSender) {
		enyo.log("Setting Public Writable...");
		smbSettings.Public.writable = inSender.checked;
		samba.setPref("Public", "writable", inSender.checked);
	},
	
	publicBrowseableChanged: function(inSender) {
		enyo.log("Setting Public Browseable...");
		smbSettings.Public.browseable = inSender.checked;
		samba.setPref("Public", "browseable", inSender.checked);
	},
	
	internalOpenChanged: function(inSender) {
		enyo.log("Setting Internal Open...");
		uiPrefs.Internal.open = inSender.open;
	},
	
	internalAvailableChanged: function(inSender) {
		enyo.log("Setting Internal Available...");
		smbSettings.Internal.available = inSender.checked;
		samba.setPref("Internal", "available", inSender.checked);
	},
	
	internalWriteableChanged: function(inSender) {
		enyo.log("Setting Internal Writable...");
		smbSettings.Internal.writable = inSender.checked;
		samba.setPref("Internal", "writable", inSender.checked);
	},
	
	internalBrowseableChanged: function(inSender) {
		enyo.log("Setting Internal Browseable...");
		smbSettings.Internal.browseable = inSender.checked;
		samba.setPref("Internal", "browseable", inSender.checked);
	},
	
	rootOpenChanged: function(inSender) {
		enyo.log("Setting Root Open...");
		uiPrefs.Root.open = inSender.open;
		prefStorage.save();
	},
	
	rootAvailableChanged: function(inSender) {
		enyo.log("Setting Root Available...");
		smbSettings.Root.available = inSender.checked;
		samba.setPref("Root", "available", inSender.checked);
	},
	
	rootWriteableChanged: function(inSender) {
		enyo.log("Setting Root Writeable...");
		smbSettings.Root.writable = inSender.checked;
		samba.setPref("Root", "writable", inSender.checked);
	},
	
	rootBrowseableChanged: function(inSender) {
		enyo.log("Setting Root Browseable...");
		smbSettings.Root.browseable = inSender.checked;
		samba.setPref("Root", "browseable", inSender.checked);
	},
	
	ext3fsOpenChanged: function(inSender) {
		enyo.log("Setting ext3fs Open...");
		uiPrefs.ext3fs.open = inSender.open;
	},
	
	ext3fsAvailableChanged: function(inSender) {
		enyo.log("Setting ext3fs Available...");
		smbSettings.ext3fs.available = inSender.checked;
		samba.setPref("ext3fs", "available", inSender.checked);
	},
	
	ext3fsWriteableChanged: function(inSender) {
		enyo.log("Setting ext3fs Writeable...");
		smbSettings.ext3fs.writable = inSender.checked;
		samba.setPref("ext3fs", "writable", inSender.checked);
	},
	
	ext3fsBrowseableChanged: function(inSender) {
		enyo.log("Setting ext3fs Browseable...");
		smbSettings.ext3fs.browseable = inSender.checked;
		samba.setPref("ext3fs", "browseable", inSender.checked);
	},
});