//Samba Control Service kind
enyo.kind({
	name: "SambaService",
	kind: enyo.Component,
	events: {
		"onActivated" : "",
		"onDeactivated" : "",
		"onPrefsLoaded" : "",
	},
	components: [
		{name: "activateSamba", kind: "sambaServ",	method: "activate",	onSuccess: "sambaActivated"},
		{name: "deactivateSamba", kind: "sambaServ", method: "deactivate", onSuccess: "sambaDeactivated"},
		
		{name: "getPrefSamba", kind: "sambaServ", method: "getPref", onSuccess: "getSuccess"},
		{name: "setPrefSamba", kind: "sambaServ", method: "setPref", onSuccess: "setSuccess"},
		
		{name: "scanExt3FS", kind: "sambaServ", method: "scanExt3FS", onSuccess: "ext3fsSuccess"},
	],
	
	//Functions
	activate: function() {
		enyo.error("Calling Samba Service...");
		this.$.activateSamba.call();
	},
	
	deactivate: function() {
		enyo.error("Calling Samba Service...");
		this.$.deactivateSamba.call();
	},
	
	getPref: function(argCategory, argPref) {
		enyo.error("Getting " + argPref + " in " + argCategory + ".");
		this.$.getPrefSamba.call({
			inCategory: argCategory,
			inPref: argPref,
		});
	},
	
	setPref: function(argCategory, argPref, argValue) {
		enyo.error("Setting " + argPref + " in " + argCategory + " to " + argValue + ".");
		this.$.setPrefSamba.call({
			inCategory: argCategory,
			inPref: argPref,
			inValue: argValue,
		});
		smbSettings[argCategory][argPref] = argValue;
	},
	
	detectExt3FS: function() {
		enyo.error("Scanning for ext3fs...");
		this.$.scanExt3FS.call();
	},
	
	//Event Handlers
	sambaActivated: function(inSender, inResponse) {
		this.doActivated();
	},
	
	sambaDeactivated: function(inSender, inResponse) {
		this.doDeactivated();
	},
	
	getSuccess: function(inSender, inResponse) {
		//enyo.error("Retrieved " + inResponse.pref + " in " + inResponse.category + ": " + inResponse.reply);
		//If value contains true or false, convert it to boolean otherwise the prefs items don't work.
		var value = inResponse.reply;
		
		if (value.indexOf("true") != -1) value = true;
		else if (value.indexOf("false") != -1) value = false;
		
		smbSettings[inResponse.category][inResponse.pref] = value;
		
		//Activate the Preferences Button
		this.doPrefsLoaded();
	},
	
	setSuccess: function(inSender, inResponse) {
		enyo.error("Preference Set: " + inResponse.stdout);
	},
	
	ext3fsSuccess: function(inSender, inResponse) {
		enyo.error("/media/ext3fs exists?", inResponse.reply);
		smbSettings.ext3fs.detected = inResponse.reply;
		smbSettings.ext3fs.available = inResponse.reply;
	},
});

//PalmService Template
enyo.kind({
	kind: enyo.PalmService,
	name: "sambaServ",
	subscribe: false,
	service: "palm://com.shiftyaxel.wifisharing.samba",
});